From 665b7f5b6cf0fc5ba61c8e4f5d6d9247eda52e97 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 10 2020 20:04:51 +0000
Subject: [PATCH 1688/2232] Merge pull request #560 from dtolnay/relocatable


Mark all shared structs as relocatable
---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 851b953..cae9357 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -233,9 +233,7 @@ fn write_struct<'a>(out: &mut OutFile<'a>, strct: &'a Struct, methods: &[&Extern
         writeln!(out, "{};", field.ident);
     }
 
-    if !methods.is_empty() || operator_eq || operator_ord {
-        writeln!(out);
-    }
+    writeln!(out);
 
     for method in methods {
         write!(out, "  ");
@@ -281,6 +279,9 @@ fn write_struct<'a>(out: &mut OutFile<'a>, strct: &'a Struct, methods: &[&Extern
         );
     }
 
+    out.include.type_traits = true;
+    writeln!(out, "  using IsRelocatable = ::std::true_type;");
+
     writeln!(out, "}};");
     writeln!(out, "#endif // {}", guard);
 }

